package com.terraformersmc.traverse.block;

import com.terraformersmc.terraform.block.*;
import com.terraformersmc.terraform.feature.TerraformOakTreeFeature;
import com.terraformersmc.terraform.util.RecipeUtil;
import com.terraformersmc.terraform.util.TerraformSaplingGenerator;
import com.terraformersmc.traverse.Traverse;
import com.terraformersmc.traverse.feature.FirTreeFeature;
import net.fabricmc.fabric.api.block.FabricBlockSettings;
import net.fabricmc.fabric.api.registry.FlammableBlockRegistry;
import net.fabricmc.fabric.api.registry.FuelRegistry;
import net.minecraft.block.*;
import net.minecraft.class_1747;
import net.minecraft.class_1761;
import net.minecraft.class_1792;
import net.minecraft.class_1822;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2349;
import net.minecraft.class_2354;
import net.minecraft.class_2378;
import net.minecraft.class_2410;
import net.minecraft.class_2482;
import net.minecraft.class_2960;
import net.minecraft.class_3111;
import net.minecraft.class_3620;
import java.util.HashMap;
import java.util.Map;

public class TraverseBlocks {

	private static final Map<class_2960, class_1747> ITEMS = new HashMap<>();
	private static final Map<class_2960, class_2248> BLOCKS = new HashMap<>();

	public static final class_2248 RED_AUTUMNAL_LEAVES = add("red_autumnal_leaves", new TerraformLeavesBlock(), class_1761.field_7928);
	public static final class_2248 RED_AUTUMNAL_SAPLING = add("red_autumnal_sapling", new TerraformSaplingBlock(new TerraformSaplingGenerator(() -> new TerraformOakTreeFeature(class_3111::method_13565, true, class_2246.field_10010.method_9564(), RED_AUTUMNAL_LEAVES.method_9564()))), class_1761.field_7928);
	public static final class_2248 BROWN_AUTUMNAL_LEAVES = add("brown_autumnal_leaves", new TerraformLeavesBlock(), class_1761.field_7928);
	public static final class_2248 BROWN_AUTUMNAL_SAPLING = add("brown_autumnal_sapling", new TerraformSaplingBlock(new TerraformSaplingGenerator(() -> new TerraformOakTreeFeature(class_3111::method_13565, true, 5, class_2246.field_10431.method_9564(), BROWN_AUTUMNAL_LEAVES.method_9564()))), class_1761.field_7928);
	public static final class_2248 ORANGE_AUTUMNAL_LEAVES = add("orange_autumnal_leaves", new TerraformLeavesBlock(), class_1761.field_7928);
	public static final class_2248 ORANGE_AUTUMNAL_SAPLING = add("orange_autumnal_sapling", new TerraformSaplingBlock(new TerraformSaplingGenerator(() -> new TerraformOakTreeFeature(class_3111::method_13565, true, class_2246.field_10431.method_9564(), ORANGE_AUTUMNAL_LEAVES.method_9564()))), class_1761.field_7928);
	public static final class_2248 YELLOW_AUTUMNAL_LEAVES = add("yellow_autumnal_leaves", new TerraformLeavesBlock(), class_1761.field_7928);
	public static final class_2248 YELLOW_AUTUMNAL_SAPLING = add("yellow_autumnal_sapling", new TerraformSaplingBlock(new TerraformSaplingGenerator(() -> new TerraformOakTreeFeature(class_3111::method_13565, true, 6, class_2246.field_10511.method_9564(), YELLOW_AUTUMNAL_LEAVES.method_9564()))), class_1761.field_7928);

	public static final class_2248 FIR_PLANKS = add("fir_planks", new class_2248(FabricBlockSettings.copy(class_2246.field_10161).build()), class_1761.field_7931);
	public static final class_2248 FIR_SAPLING = add("fir_sapling", new TerraformSaplingBlock(new TerraformSaplingGenerator(() -> new FirTreeFeature(class_3111::method_13565, true))), class_1761.field_7928);
	public static final class_2248 STRIPPED_FIR_LOG = add("stripped_fir_log", new class_2410(class_3620.field_15977, FabricBlockSettings.copy(class_2246.field_10431).build()), class_1761.field_7931);
	public static final class_2248 STRIPPED_FIR_WOOD = add("stripped_fir_wood", new class_2410(class_3620.field_15977, FabricBlockSettings.copy(class_2246.field_10431).build()), class_1761.field_7931);
	public static final class_2248 FIR_LOG = add("fir_log", new StrippableLogBlock(() -> STRIPPED_FIR_LOG, class_3620.field_15977, FabricBlockSettings.copy(class_2246.field_10010).build()), class_1761.field_7931);
	public static final class_2248 FIR_WOOD = add("fir_wood", new StrippableLogBlock(() -> STRIPPED_FIR_WOOD, class_3620.field_15977, FabricBlockSettings.copy(class_2246.field_10010).build()), class_1761.field_7931);
	public static final class_2248 FIR_LEAVES = add("fir_leaves", new TerraformLeavesBlock(), class_1761.field_7928);
	public static final class_2248 FIR_SLAB = add("fir_slab", new class_2482(FabricBlockSettings.copy(class_2246.field_10119).build()), class_1761.field_7931);
	public static final class_2248 FIR_PRESSURE_PLATE = add("fir_pressure_plate", new TerraformPressurePlateBlock(FabricBlockSettings.copy(class_2246.field_10484).build()), class_1761.field_7914);
	public static final class_2248 FIR_FENCE = add("fir_fence", new class_2354(FabricBlockSettings.copy(class_2246.field_10620).build()), class_1761.field_7928);
	public static final class_2248 FIR_TRAPDOOR = add("fir_trapdoor", new TerraformTrapdoorBlock(FabricBlockSettings.copy(class_2246.field_10620).build()), class_1761.field_7914);
	public static final class_2248 FIR_FENCE_GATE = add("fir_fence_gate", new class_2349(FabricBlockSettings.copy(class_2246.field_10620).build()), class_1761.field_7914);
	public static final class_2248 FIR_STAIRS = add("fir_stairs", new TerraformStairsBlock(FIR_PLANKS, FabricBlockSettings.copy(class_2246.field_10563).build()), class_1761.field_7931);
	public static final class_2248 FIR_BUTTON = add("fir_button", new TerraformButtonBlock(FabricBlockSettings.copy(class_2246.field_10057).build()), class_1761.field_7914);
	public static final class_2248 FIR_DOOR = add("fir_door", new TerraformDoorBlock(FabricBlockSettings.copy(class_2246.field_10149).build()), class_1761.field_7914);
	private static final class_2960 FIR_SIGN_TEXTURE = new class_2960(Traverse.MOD_ID, "textures/entity/signs/fir.png");
	public static final class_2248 FIR_SIGN = add("fir_sign", new TerraformSignBlock(FIR_SIGN_TEXTURE, FabricBlockSettings.copy(class_2246.field_10121).build()));
	public static final class_2248 FIR_WALL_SIGN = add("fir_wall_sign", new TerraformWallSignBlock(FIR_SIGN_TEXTURE, FabricBlockSettings.copy(class_2246.field_10187).build()));
	public static final class_1792 FIR_SIGN_ITEM = add("fir_sign", new class_1822(new class_1792.class_1793().method_7889(16).method_7892(class_1761.field_7928), FIR_SIGN, FIR_WALL_SIGN));

	private static <B extends class_2248> B add(String name, B block, class_1761 tab) {
		return add(name, block, new class_1747(block, new class_1792.class_1793().method_7892(tab)));
	}

	private static <B extends class_2248> B add(String name, B block, class_1747 item) {
		add(name, block);
		if (item != null) {
			item.method_7713(class_1792.field_8003, item);
			ITEMS.put(new class_2960(Traverse.MOD_ID, name), item);
			RecipeUtil.registerCompostableBlock(block);
		}
		return block;
	}

	private static <B extends class_2248> B add(String name, B block) {
		BLOCKS.put(new class_2960(Traverse.MOD_ID, name), block);
		return block;
	}

	private static <I extends class_1747> I add(String name, I item) {
		item.method_7713(class_1792.field_8003, item);
		ITEMS.put(new class_2960(Traverse.MOD_ID, name), item);
		return item;
	}

	public static void register() {
		for (class_2960 id : ITEMS.keySet()) {
			class_2378.method_10230(class_2378.field_11142, id, ITEMS.get(id));
		}
		for (class_2960 id : BLOCKS.keySet()) {
			class_2378.method_10230(class_2378.field_11146, id, BLOCKS.get(id));
		}
		addFuels();
		addFlammables();
	}

	private static void addFuels() {
		FuelRegistry fuelRegistry = FuelRegistry.INSTANCE;
		fuelRegistry.add(FIR_FENCE, 300);
		fuelRegistry.add(FIR_FENCE_GATE, 300);
	}

	private static void addFlammables() {
		FlammableBlockRegistry flammableRegistry = FlammableBlockRegistry.getDefaultInstance();
		flammableRegistry.add(FIR_PLANKS, 5, 20);
		flammableRegistry.add(FIR_SLAB, 5, 20);
		flammableRegistry.add(FIR_FENCE_GATE, 5, 20);
		flammableRegistry.add(FIR_FENCE, 5, 20);
		flammableRegistry.add(FIR_STAIRS, 5, 20);
		flammableRegistry.add(FIR_LOG, 5, 5);
		flammableRegistry.add(STRIPPED_FIR_LOG, 5, 5);
		flammableRegistry.add(STRIPPED_FIR_WOOD, 5, 5);
		flammableRegistry.add(FIR_WOOD, 5, 5);
		flammableRegistry.add(FIR_LEAVES, 30, 60);
		flammableRegistry.add(RED_AUTUMNAL_LEAVES, 30, 60);
		flammableRegistry.add(BROWN_AUTUMNAL_LEAVES, 30, 60);
		flammableRegistry.add(ORANGE_AUTUMNAL_LEAVES, 30, 60);
		flammableRegistry.add(YELLOW_AUTUMNAL_LEAVES, 30, 60);
	}

}
